using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication1
{
	// The type definition for a 'calculate' callback function.
	public delegate double CalculateDelegate(double op1, double op2);

    public partial class Form1 : Form
    {
		public CalculateDelegate calculateCallback;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

		private void button1_Click(object sender, EventArgs e)
		{
			double operand1, operand2, result;

			// Extract the two operands from the form and parse them.
			try
			{
				operand1 = Double.Parse(operand1Textbox.Text);
				operand2 = Double.Parse(operand2Textbox.Text);
			}
			catch (FormatException exception)
			{
				// If the user input an invalid number, display an
				// error message and abort further processing.
				MessageBox.Show("An invalid number was entered as " +
					"one of the operands.", "Invalid number format",
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				return;
			}

			// Once we have the two operands we call the function that
			// does the actual calculation.
			result = calculateCallback(operand1, operand2);

			// Once the calculation is done, we display the result.
			resultTextbox.Text = result.ToString();
		}
    }
}